//+------------------------------------------------------------------+
//|                                            TsaktuoDealClient.mq4 |
//|                                                          Tsaktuo |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Tsaktuo"
#property link      "http://www.metaquotes.net"

#include <winsock.mqh>  // MQL4ҳ
                        // صַ:   http://codebase.mql4.com/download/18644
                        // :    http://codebase.mql4.com/6122

#property show_inputs   // ʾ

//--- 궨
#define OP_IN 0
#define OP_OUT 1
#define OP_INOUT 2
#define OP_OUTALL 3 // Custom DEAL ENTRY type.
//--- 
extern int     InpServerPort=2011;
extern string  InpServerIP="127.0.0.1";
extern int     InpVolumePrecision=2;
extern int     InpSlippage=3;
extern string _1="--- LOT MAPPING ---";
extern double  InpMinLocalLotSize=0.01;
extern double  InpMaxLocalLotSize=1.00; // Ƽ
extern double  InpMinRemoteLotSize =      0.01;
extern double  InpMaxRemoteLotSize =      15.00;
//--- ⲿ
int iSocketHandle=0;
//+------------------------------------------------------------------+
//| ڰıָΪַĺ                               |
//+------------------------------------------------------------------+
int Split(string text,string splitter,int max,string &array[])
  {
   int iStart = 0;
   int iCount = 0;
   int iPreviousStart=0;

   if(ArrayResize(array,0)!=0)
      Print("鳤Ϊ0ʧ.");

   while(iStart>=0)
     {
      iStart=StringFind(text,splitter,iPreviousStart);
      if(iStart>=0)
        {
         iStart++;
         if(iStart-iPreviousStart-1>0)
           {
            ArrayResize(array,iCount+1);
            array[iCount]=StringSubstr(text,iPreviousStart,iStart-iPreviousStart-1);
            iCount++;
           }
         iPreviousStart=iStart;
         if(iCount>=max)
           {
            return(iCount);
           }
        }
      else
        {
         ArrayResize(array,iCount+1);
         array[iCount]=StringSubstr(text,iPreviousStart,EMPTY);
         iCount++;
        }
     }
   return(iCount);
  }
//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
int start()
  {
   int iBuffer[100];
   int iRetVal;
   int iAddr[1];
   int iServer[sockaddr_in];
   int hp;
   int wsaData[WSADATA];
   string sLeftOver="";

   Print("ͻ˰汾: 1.0, :Tsaktuo,  2011");

//--- ׼׽
   iRetVal=WSAStartup(0x202,wsaData);
   if(iRetVal!=0)
     {
      Print("ͻ: WSAStartup() ʧܣ "+iRetVal);
      return(-1);
     }
   else
     {
      Print("ͻ: WSAStartup() ɹ.");
     }
   iAddr[0]=inet_addr(InpServerIP);
   hp=gethostbyaddr(iAddr[0],4,AF_INET);
   Print("ͻˣַ"+iAddr[0]+" hp"+hp);
   int2struct(iServer,sin_addr,iAddr[0]);
   int2struct(iServer,sin_family,AF_INET);
   int2struct(iServer,sin_port,htons(InpServerPort));

//--- ׽
   iSocketHandle=socket(AF_INET,SOCK_STREAM,0);
   if(iSocketHandle<0)
     {
      Print("ͻˣ׽ִ󣺴 "+WSAGetLastError());
      return(-1);
     }
   else
     {
      Print("ͻ: socket() ִгɹ.");
     }

//--- ׽ֵ
   Print("ͻ: ͻӵ: "+InpServerIP);
   iRetVal=connect(iSocketHandle,iServer,ArraySize(iServer)<<2);
   if(iRetVal==SOCKET_ERROR)
     {
      if(WSAGetLastError()==WSAECONNREFUSED)
        {
         Print("ͻ: connect() ʧܣû.");
        }
      else
        {
         Print("ͻ: connect() ʧ: ",WSAGetLastError());
        }
      return(-1);
     }
   else
      Print("ͻ: connect() ִгɹ.");

//--- Уʼռʹ
   while(!IsStopped())
     {
      Print("ͻˣȴ...");
      ArrayInitialize(iBuffer,0);
      iRetVal=recv(iSocketHandle,iBuffer,ArraySize(iBuffer)<<2,0);
      if(iRetVal>0)
        {
         string sRawData=struct2str(iBuffer,iRetVal<<18);
         Print("Received("+iRetVal+"): "+sRawData);
         //--- ǷûκҪǰһݰ
         if(StringLen(sLeftOver)>0)
           {
            sRawData = StringConcatenate(sLeftOver,sRawData);
            iRetVal += StringLen(sLeftOver);
            Print("ǰһݰҪ:("+iRetVal+"): "+sRawData);
            sLeftOver=""; // ʣ.
           }
         //--- ָ¼ 
         string arrDeals[];
         //--- ԭʼݷָɶףյ˶ݵĻ
         int iDealsReceived=Split(sRawData,"<",10,arrDeals);
         Print("ҵ ",iDealsReceived," ׶.");
         //--- ÿ¼
         //--- յĽ
         for(int j=0;j<iDealsReceived;j++) 
           {
            //--- ÿʽ׷ָõֵ
            string arrValues[];
            //--- ÿʽ׷ָõֵ
            int iValuesInDeal=Split(arrDeals[j],";",10,arrValues);
            //--- ȷյĽʽȷ(ֵȷ)
            if(iValuesInDeal==6)
              {
               if(ProcessOrderRaw(arrValues[0],arrValues[1],arrValues[2],arrValues[3],arrValues[4],StringSubstr(arrValues[5],0,StringLen(arrValues[5])-1)))
                 {
                  Print("ɹ.");
                 }
               else
                 {
                  Print("ʧ:\"",arrDeals[j],"\"");
                 }
              }
            else
              {
               Print("յĶЧ:\"",arrDeals[j],"\"");
               //--- һ
               if(j==iDealsReceived-1)
                 {
                  //--- һײĿͷ.
                  sLeftOver=arrDeals[j];
                 }
              }
           }
        }
      else if(iRetVal<=0)
        {
         Print("ͻ: recv() ʧ:  ",WSAGetLastError());
         break;
        }
      //--- sleep ǱģΪrecv() ģʽ
      //--- ֪յĳЩݣ򲻻᷵
     }
//--- ׽ֻڴ״̬ر
   if(iSocketHandle>0)
     {
      Print("ر...");
      closesocket(iSocketHandle);
     }
   WSACleanup();
   Print("ͻֹͣ.");
   return(0);
  }

//==============  ߺ ==================================================
//+------------------------------------------------------------------+
//| ȥո                                                         |
//+------------------------------------------------------------------+
string Trim(string text)
  {
   return(StringTrimRight(StringTrimLeft(text)));
  }
//+------------------------------------------------------------------+
//| ֤˺Ÿʽ                                                     |
//+------------------------------------------------------------------+
bool ValidateAccountNumber(string account)
  {
   if(StringLen(account)==0)
      return(false);
   if(StrToInteger(account)>0)
      return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//| ֤յĽƷָʽ                                           |
//+------------------------------------------------------------------+
bool ValidateSymbol(string symbol)
  {
   if(StringLen(symbol)==0)
      return(false);
   if(MarketInfo(symbol,MODE_DIGITS)>0)
      return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//| ֤                                                     |
//+------------------------------------------------------------------+
bool ValidateType(string type)
  {
   if(StringLen(type)==0)
      return(false);
   if(type=="BUY")
      return(true);
   if(type=="SELL")
      return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//| ֤׼¼                                                 |
//+------------------------------------------------------------------+
bool ValidateEntry(string entry)
  {
   if(StringLen(entry)==0)
      return(false);
   if(entry=="IN")
      return(true);
   if(entry=="OUT")
      return(true);
   if(entry=="INOUT")
      return(true);
  //--- ֧Զʽ. ( MQL5 TsaktuoDealServer Դ)
   if(entry=="OUTALL") 
      return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//| ֤Сʽ                                                 |
//+------------------------------------------------------------------+
bool ValidateVolume(string volume)
  {
   if(StringLen(volume)==0)
      return(false);
   if(StrToDouble(volume)>0)
      return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//| ֤۸ʽ                                                     |
//+------------------------------------------------------------------+
bool ValidatePrice(string price)
  {
   if(StringLen(price)==0)
      return(false);
   if(StrToDouble(price)>0)
      return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//| ıתΪ                                             |
//+------------------------------------------------------------------+
int String2Type(string type)
  {
   if(type=="BUY")
      return(OP_BUY);
   if(type=="SELL")
      return(OP_SELL);
   return(-1);
  }
//+------------------------------------------------------------------+
//| ѽתΪı                                             |
//+------------------------------------------------------------------+
string Type2String(int type)
  {
   if(type==OP_BUY)
      return("BUY");
   if(type==OP_SELL)
      return("SELL");
   return("?");
  }
//+------------------------------------------------------------------+
//| ıתΪ׼¼                                             |
//+------------------------------------------------------------------+
int String2Entry(string entry)
  {
   if(entry=="IN")
      return(OP_IN);
   if(entry=="OUT")
      return(OP_OUT);
   if(entry=="INOUT")
      return(OP_INOUT);
   if(entry=="OUTALL")
      return(OP_OUTALL);
   return(-1);
  }
//+------------------------------------------------------------------+
//| ѽ׼¼תΪı                                             |
//+------------------------------------------------------------------+
string Entry2String(int entry)
  {
   if(entry==OP_IN)
      return("IN");
   if(entry==OP_OUT)
      return("OUT");
   if(entry==OP_INOUT)
      return("INOUT");
   if(entry==OP_OUTALL)
      return("OUTALL");
   return("?");
  }
//=======================================  ==================================================

//+------------------------------------------------------------------+
//| յԭʼݣıʽ                                   |
//+------------------------------------------------------------------+
bool ProcessOrderRaw(string saccount,string ssymbol,string stype,string sentry,string svolume,string sprice)
  {
//--- 
   saccount= Trim(saccount);
   ssymbol = Trim(ssymbol);
   stype=Trim(stype);
   sentry=Trim(sentry);
   svolume= Trim(svolume);
   sprice = Trim(sprice);
//--- ֤
   if(!ValidateAccountNumber(saccount)){Print("Invalid account:",saccount);return(false);}
   if(!ValidateSymbol(ssymbol)){Print("Invalid symbol:",ssymbol);return(false);}
   if(!ValidateType(stype)){Print("Invalid type:",stype);return(false);}
   if(!ValidateEntry(sentry)){Print("Invalid entry:",sentry);return(false);}
   if(!ValidateVolume(svolume)){Print("Invalid volume:",svolume);return(false);}
   if(!ValidatePrice(sprice)){Print("Invalid price:",sprice);return(false);}
//--- ת
   int account=StrToInteger(saccount);
   string symbol=ssymbol;
   int type=String2Type(stype);
   int entry=String2Entry(sentry);
   double volume= GetLotSize(StrToDouble(svolume),symbol);
   double price = NormalizeDouble(StrToDouble(sprice),(int)MarketInfo(ssymbol,MODE_DIGITS));
   Print("DEAL[",account,"|",symbol,"|",Type2String(type),"|",Entry2String(entry),"|",volume,"|",price,"]");
//--- ִ
   ProcessOrder(account,symbol,type,entry,volume,price);
   return(true);
  }
//+------------------------------------------------------------------+
//| ת֤ݴ                                     |
//+------------------------------------------------------------------+
void ProcessOrder(int account,string symbol,int type,int entry,double volume,double price)
  {
   if(entry==OP_IN)
     {
      DealIN(symbol,type,volume,price,0,0,account);
     }
   else if(entry==OP_OUT)
     {
      DealOUT(symbol,type,volume,price,0,0,account);
     }
   else if(entry==OP_INOUT)
     {
      DealOUT_ALL(symbol,type,account);
      DealIN(symbol,type,volume,price,0,0,account);
     }
   else if(entry==OP_OUTALL)
     {
      DealOUT_ALL(symbol,type,account);
     }
  }
//+------------------------------------------------------------------+
//|  IN ͽ                                                 |
//+------------------------------------------------------------------+
void DealIN(string symbol,int cmd,double volume,double price,double stoploss,double takeprofit,int account)
  {
   double prc=0;

   if(cmd==OP_SELL)
      prc= MarketInfo(symbol,MODE_BID);
   else if(cmd==OP_BUY)
      prc=MarketInfo(symbol,MODE_ASK);

   string comment="IN."+Type2String(cmd);

   int iRetVal=OrderSend(symbol,cmd,volume,prc,InpSlippage,stoploss,takeprofit,comment,account);
   if(iRetVal<0)
     {
      int retries=0;
      int error=0;

      while(iRetVal<0 && retries<10)
        {
         error=GetLastError();
         Print("DealIN error code: ",error);
         //--- Ҫ
         if(error!=146 && error!=4 && error!=6)
            break;

         Sleep(500);

         if(cmd==OP_SELL)
            prc= MarketInfo(symbol,MODE_BID);
         else if(cmd==OP_BUY)
            prc=MarketInfo(symbol,MODE_ASK);

         iRetVal=OrderSend(symbol,cmd,volume,prc,InpSlippage,stoploss,takeprofit,comment,account);

         if(iRetVal<0) retries++;
         else break;
        }

      if(iRetVal<0)
         Print("ִжʧ! : ",GetLastError());
     }
  }
//+------------------------------------------------------------------+
//|  OUT ͽ                                          |
//+------------------------------------------------------------------+
void DealOUT(string symbol,int cmd,double volume,double price,double stoploss,double takeprofit,int account)
  {
   int type=-1;
   int i=0;

   if(cmd==OP_SELL)
      type=OP_BUY;
   else if(cmd==OP_BUY)
      type=OP_SELL;

   string comment="OUT."+Type2String(cmd);

//--- --- ѰͬС0Ķ
   for(i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==account)
           {
            if(OrderSymbol()==symbol)
              {
               if(OrderType()==type)
                 {
                  if(OrderLots()==volume)
                    {
                     if(CloseOneOrder(OrderTicket(),symbol,type,volume))
                       {
                        Print("ѾҵСͬ0Ķִϡ");
                        return;
                       }
                    }
                 }
              }
           }
        }
     }
   double volume_to_clear=volume;
//--- ѰСĶ
   int limit=OrdersTotal();
   for(i=0;i<limit;i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==account)
           {
            if(OrderSymbol()==symbol)
              {
               if(OrderType()==type)
                 {
                  if(OrderLots()<=volume_to_clear)
                    {
                     if(CloseOneOrder(OrderTicket(),symbol,type,OrderLots()))
                       {
                        Print("ѾҵͬСִС");
                        volume_to_clear-=OrderLots();
                        if(volume_to_clear==0)
                          {
                           Print("СѾر.");
                           return;
                          }
                        limit=OrdersTotal();
                        //---  ΪѭǰӣΪ0.
                        i=-1; 
                       }
                    }
                 }
              }
           }
        }
     }
//--- ѰҶСϴĶ
   for(i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==account)
           {
            if(OrderSymbol()==symbol)
              {
               if(OrderType()==type)
                 {
                  if(OrderLots()>=volume_to_clear)
                    {
                     if(CloseOneOrder(OrderTicket(),symbol,type,OrderLots()))
                       {
                        Print("СϴĶѾҵִ.");
                        volume_to_clear-=OrderLots();
                        //--- ر̫ඩ
                        if(volume_to_clear<0)
                          {
                           //--- ¶رնĲ
                           DealIN(symbol,type,volume_to_clear,price,OrderStopLoss(),OrderTakeProfit(),account);
                          }
                        else if(volume_to_clear==0)
                          {
                           Print("趩ѹر.");
                           return;
                          }
                       }
                    }
                 }
              }
           }
        }
     }
   if(volume_to_clear!=0)
     {
      Print("һСĶʣδر: ",volume_to_clear);
     }
  }
//+------------------------------------------------------------------+
//| رһָĶ                                               |
//+------------------------------------------------------------------+
bool CloseOneOrder(int ticket,string symbol,int cmd,double lots)
  {
   double prc=0;
   if(cmd==OP_SELL)
      prc= MarketInfo(symbol,MODE_ASK);
   else if(cmd==OP_BUY)
      prc=MarketInfo(symbol,MODE_BID);

   int iRetVal=OrderClose(ticket,lots,prc,InpSlippage);
   if(iRetVal<0)
     {
      int retries=0;
      int error=0;

      while(iRetVal<0 && retries<10)
        {
         error=GetLastError();
         Print("DealOUT error code: ",error);
         //--- Ҫ
         if(error!=146 && error!=4 && error!=6)
            break;

         Sleep(500);

         if(cmd==OP_SELL)
            prc= MarketInfo(symbol,MODE_ASK);
         else if(cmd==OP_BUY)
            prc=MarketInfo(symbol,MODE_BID);

         iRetVal=OrderClose(ticket,lots,prc,InpSlippage);

         if(iRetVal<0) retries++;
         else break;
        }

      if(iRetVal<0)
        {
         Print("ִжʧܣ: ",GetLastError());
         return(false);
        }
     }
   return(true);
  }
//+------------------------------------------------------------------+
//| رĳƷֵж                                         |
//+------------------------------------------------------------------+
void DealOUT_ALL(string symbol,int cmd,int account)
  {
   int type=-1;

   if(cmd==OP_SELL)
      type=OP_BUY;
   else if(cmd==OP_BUY)
      type=OP_SELL;

//--- ж
   int limit= OrdersTotal();
   for(int i=0;i<limit;i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==account)
           {
            if(OrderSymbol()==symbol)
              {
               if(OrderType()==type)
                 {
                  if(CloseOneOrder(OrderTicket(),symbol,type,OrderLots()))
                    {
                     Print("OUT_ALL: ҵִ.");
                     limit=OrdersTotal();
                     //--- Ϊѭĩ1Ϊ0.
                     i=-1; 
                    }
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| 㽻                                                     |
//+------------------------------------------------------------------+
double GetLotSize(string remote_lots,string symbol)
  {
   double dRemoteLots=StrToDouble(remote_lots);
   double dLocalLotDifference=InpMaxLocalLotSize-InpMinLocalLotSize;
   double dRemoteLotDifference=InpMaxRemoteLotSize-InpMinRemoteLotSize;
   double dLots=dLocalLotDifference *(dRemoteLots/dRemoteLotDifference);
   double dMinLotSize=MarketInfo(symbol,MODE_MINLOT);
   if(dLots<dMinLotSize)
      dLots=dMinLotSize;
   return(NormalizeDouble(dLots,InpVolumePrecision));
  }
//+------------------------------------------------------------------+

